Skip to main content
`Ctrl`+`K`

# MatDenseCUDAGetArrayRead

Provides read-only access to the CUDA buffer inside a `MATDENSECUDA` matrix. The array must be restored with `MatDenseCUDARestoreArrayRead()` when no longer needed.

## Synopsis

    PetscErrorCode MatDenseCUDAGetArrayRead(Mat A, const PetscScalar **a)

Not Collective

## Input Parameter

- A - the matrix

## Output Parameter

- a - the GPU array in column major order

## Note

Data may be copied to the GPU due to operations done on the CPU. If you need write only access, use `MatDenseCUDAGetArrayWrite()`.

## See Also

`MATDENSECUDA`, `MatDenseCUDAGetArray()`, `MatDenseCUDARestoreArray()`, `MatDenseCUDARestoreArrayWrite()`, `MatDenseCUDAGetArrayWrite()`, `MatDenseCUDARestoreArrayRead()`

## Level

developer

## Location

src/mat/impls/dense/mpi/cupm/cuda/matmpidensecuda.cu

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages